#ifdef DEBUG
#define FUNC_DEBUG 20

EXTREF int bugdlvl;


#define DEBUG_ENTER(name, args)	  char *dbg_name=name;\
  				  if (bugdlvl >= FUNC_DEBUG) {\
				    printf("> %s[%d](", dbg_name, debuglbolt());\
				    printf args;\
				    printf(")\n");}

#define DEBUG_TRACE(level, args)  ( (bugdlvl >= level)? (\
				    printf args , printf("\n"),0):0)

#define DEBUG_INT_RETURN(arg)	  return(((bugdlvl >= FUNC_DEBUG)?\
				    (printf("< %s[%d](%d)\n", dbg_name, debuglbolt(), (arg)),0)\
					  :0),(arg))

#define DEBUG_LONG_RETURN(arg)	  return(((bugdlvl >= FUNC_DEBUG)?\
				    (printf("< %s[%d](%d)\n", dbg_name, debuglbolt(), (arg)),0)\
					  :0),(arg))

#define DEBUG_PTR_RETURN(arg)	  return(((bugdlvl >= FUNC_DEBUG)?\
				    (printf("< %s[%d](%x)\n", dbg_name, debuglbolt(), (arg)),0)\
					  :0),(arg))


#define DEBUG_BOOL_RETURN(arg)	  return(((bugdlvl >= FUNC_DEBUG) ?\
  					(printf("<%s[%d] (%s)\n", dbg_name, debuglbolt(), \
					((arg)) ? "TRUE" : "FALSE" ),0)\
					  :0),(arg))

#define DEBUG_VOID_RETURN	  if (bugdlvl >= FUNC_DEBUG)\
					{\
    					printf("< %s[%d](void)\n", dbg_name, debuglbolt());\
				  	return;\
					}\
				  else\
					return

#else
#define DEBUG_ENTER(name, args)	  
#define DEBUG_TRACE(level, args)  
#define DEBUG_INT_RETURN(arg)	  return(arg)
#define DEBUG_LONG_RETURN(arg)	  return(arg)
#define DEBUG_PTR_RETURN(arg)	  return(arg)
#define DEBUG_BOOL_RETURN(arg)	  return(arg)
#define DEBUG_VOID_RETURN	  return

#endif


