/* Graeme Vetterlein 3-Aug-92 Copyright G. Vetterlein */
/*
 * nopdemo:
 *
 * Exercises the nop device
 * 
 */
#include "nopdemo.h"

EXTREF	char	*optarg;
EXTREF	int	optind;

#define	MAXLINE	257

static char buffer[MAXLINE];
static int	fd;


static void usage(char name[])
{
DEBUG_ENTER("usage", ("name=%s", name));

fprintf(stderr, "%s <nop device>\n", name);

DEBUG_VOID_RETURN;
}

static void doread()
{
int	size;
  
DEBUG_ENTER("doread", (""));

if ((size=read(fd, buffer, MAXLINE)) == -1)
  {
  perror("read");
  exit(1);
  }

fprintf(stderr, "Read line = (");

if (write(1, buffer, size) == -1)
  {
  perror("write");
  exit(1);
  }

fprintf(stderr, ")\n");

DEBUG_VOID_RETURN;
}

static void dowrite()
{
DEBUG_ENTER("dowrite", (""));

fprintf(stderr, "Enter line\n:");

if (fgets(buffer, MAXLINE, stdin) == NULL)
  {
  fprintf(stderr, "Failed (NULL) on fgets\n");
  exit(1);
  }

if (write(fd, buffer, strlen(buffer)+1) == -1)
  {
  perror("write");
  exit(1);
  }

fprintf(stderr,"wrote line = (%s)\n", buffer);

DEBUG_VOID_RETURN;
}






EXTDEF main(int argc, char *argv[])
{
int	rc 	= 0;
int	c;
boolean	errflg 	= FALSE;
char	*prog;
int	i;
char	*filename;
boolean done;

DEBUG_ENTER("main", ("argc=%d, argv=%x", argc, argv));

prog = argv[0];

dbginit(0);

while ((c = getopt(argc, argv, "d:")) != -1)
  {
  switch (c)
    {
    case ('d'):
      dbginit(atoi(optarg));
      break;
    case ('?'):
    default:
      errflg = TRUE;
    }
  }

if (errflg)
  {
  usage(prog);
  exit(1);
  }

DEBUG_TRACE(9, ("argc=%d\n", argc));

if ((argc-optind) != 1)
  {
  usage(prog);
  exit(1);
  }

filename=argv[optind];

if ((fd=open(filename, O_RDWR)) == -1)
  {
  perror(filename);
  exit(1);
  }

done=FALSE;

do
  {
  printf("file %s is open, choose one of the following\n", filename);
  
  printf("w = Write some text\n"
	 "r = Read (and display) a record from file\n"
	 "q = quit\n");
  

  if (fgets(buffer, MAXLINE, stdin) == NULL)
    {
    fprintf(stderr, "Failed (NULL) on fgets\n");
    exit(1);
    }
  
  switch(buffer[0])
    {
    case ('w'):
    case ('W'):
      dowrite();
      break;
      
    case ('r'):
    case ('R'):
      doread();
      break;
      
    case ('q'):
    case ('Q'):
      done=TRUE;
      break;
      
    default:
      printf("Not a valid choice (%c)\n", c);
      break;
    }
  
  
  } while (!done);


if (close(fd) == -1)
  {
  perror("close");
  exit(1);
  }


DEBUG_INT_RETURN(rc);
}
