#	copyright	"%c%"

#ident	"@(#)kit:eth/src/dlpi_ether.mk	1.3"
#ident	"$Header: $"

CONF=/etc/conf
IDINSTALL=$(CONF)/bin/idinstall
IDBUILD=$(CONF)/bin/idbuild

BUS=AT386
GLOBALDEF = -D_KERNEL -DSTATIC="" -D$(BUS) -DVPIX -DMERGE386 -DEVGA
GLOBALINC = -I$(KBASE) -I.

DEFLIST	= $(DEV1) $(LOCALDEF) $(LOCALINC) $(GLOBALDEF) $(GLOBALINC) $(DEV2)

LOCALDEF = -DNOP_STRLOG -DDEBUG

KBASE =		/usr/include
NOP =		Driver.o
NOPFILES =	nopstream.o nophrdw.o nopinit.o nopspace.o nopdebug.o
MKFILE = 	nop.mk

CFILES =  nophrdw.c nopinit.c 

HFILES = nop.h nopdebug.h nopconfig.h
HINSTALL = nopconfig.h
HINSTALLED = $(ROOT)/usr/include/sys/$(HINSTALL)


all:	$(NOP)

$(NOP):	$(NOPFILES)
	$(LD) -r -o $@ $(NOPFILES)

#
# Configuration Section
#
ID:
	cd nop.cf; $(IDINSTALL) -R$(CONF) -M nop

$(HINSTALLED):	$(HINSTALL)
	cp $(HINSTALL) $@
	
BUILD:	$(NOP) $(HINSTALLED)
	$(IDINSTALL) -o -M nop
	$(IDBUILD) -M nop

clean:
	-rm -f *.o

clobber:	clean
	-$(IDINSTALL) -R$(CONF) -e -d nop

#
# Special Header dependencies
#

nopstream.o: nopstream.c $(HFILES) $(MKFILE)
	$(CC) $(CFLAGS) $(DEFLIST) -DNOP -c nopstream.c 

.c.o:	$(HFILES) $(MKFILE)
	$(CC) $(CFLAGS) $(DEFLIST) -c $<

.c.a:
	$(CC) $(CFLAGS) $(DEFLIST) -c $<
	$(AR) $(ARFLAGS) $@ $*.o
	rm -f $*.o

.s.o:
	$(AS) $(ASFLAGS) $<

