#include "nop.h"
 
#ifdef DEBUG
EXTDEF	int	bugdlvl = FUNC_DEBUG;


EXTDEF clock_t
debuglbolt()
{
	clock_t				lbolt;

	drv_getparm (LBOLT, (ulong_t*)&lbolt);

	return lbolt;
}
#endif

STATIC void  debug_dump_datap(dblk_t *dp)
{
  DEBUG_ENTER("debug_dump_datap", ("dp=%x", dp));

  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "Dump of data block starting at %x", dp));

  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "%x -> struct datab {"           ,  dp));              
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "union <noname>*db_f=%x"	  ,  dp->db_f.freep));  
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned char *db_base=%x"	  ,  dp->db_base));     
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned char *db_lim=%x"	  ,  dp->db_lim));      
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned char  db_ref=%d"	  ,  dp->db_ref));      
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned char  db_type=%d"	  ,  dp->db_type));     
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned char  db_iswhat=%d"    ,  dp->db_iswhat));   
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "unsigned int   db_size=%d"	  ,  dp->db_size));     
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "caddr_t        db_msgaddr=%x"   ,  dp->db_msgaddr));  
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "long           db_filler=%d"    ,  dp->db_filler));
  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "}"));

    

  DEBUG_VOID_RETURN;
}

EXTDEF void  debug_dump_msgb(mblk_t *mp)
{
  DEBUG_ENTER("debug_dump_msgb", ("mp=%x", mp));

  NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		 "Dump of msg block starting at %x", mp));

  do
    {
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "%x -> struct msgb{"     ,  mp));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "struct msgb   *b_next=%x"	,  mp->b_next));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "struct msgb   *b_prev=%x"	,  mp->b_prev));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "struct msgb   *b_cont=%x"	,  mp->b_cont));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "unsigned char *b_rptr=%x"	,  mp->b_rptr)); 
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "unsigned char *b_wptr=%x"	,  mp->b_wptr)); 
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "struct datab  *b_datap=%x",  mp->b_datap)); 
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "unsigned char  b_band=%d"	,  mp->b_band));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "unsigned char  b_pad1=%d"	,  mp->b_pad1)); 
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "unsigned short b_flag=%d"	,  mp->b_flag)); 
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "long           b_pad2=%d",mp->b_pad2));
    NOP_LOG(strlog(NOP_ID, 0, 3, SL_TRACE,
		   "}"));
		   
    debug_dump_datap(mp->b_datap);
    
    } while (mp = mp->b_cont);
  

  DEBUG_VOID_RETURN;
}

