#include <nop.h>

#define BCOPY(from, to, len)	\
  bcopy((caddr_t)(from), (caddr_t)(to), (size_t)(len))

#define BCMP(s1, s2, len)	\
  bcmp((char *)(s1), (char *)(s2), (size_t)(len))

/****************************************************************************
 *  nopintr()
 ****************************************************************************/

void
nopintr (level)
int	level;
{
  nop_bdconfig_t	*bd;
  int			index;

  DEBUG_ENTER("nopintr", ("level=%d", level));

  /* map irq level to the proper board. Make sure it's ours.   */
  if ((index = nopintr_to_index [level]) == -1) 
    {
    cmn_err (CE_WARN, "%s spurious interrupt", nopid_string);
    return;
    }

  /* get pointers to structures (Based in intr No)  */
  bd      = &nopconfig [index];

  /* acknowledge XXXXX interrupt */

  /*  Store error statistics in XXXXXX */

  DEBUG_VOID_RETURN;
}


/******************************************************************************
 *  nop_m_data()
 *
 * This is called from STREAMS file  (nopwput() when data needs to be written 
 * out to hardware.
 *
 *
 ******************************************************************************/
EXTDEF void
nop_m_data(q, mp)
queue_t	*q;
mblk_t	*mp;
{
  DEBUG_ENTER("nop_m_data", ("q=%x, mp=%x",
			   q   , mp));

#ifdef DEBUG
  debug_dump_msgb(mp);
#endif

  /* 
   * Almost certainly you will want to process he message (DMA it to tape for example)
   * the free the buffer (freemsg). 
   * However just for fun here we stick it on the read side's queue, so the service routine
   * gets some exercise.
   *
   *freemsg(mp);
   */

  putq(RD(q), mp);
  
  DEBUG_VOID_RETURN;
}
